/**
 * Copyright 2008 Peach Jean Solutions
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.xj4.lifecycle;

import java.lang.reflect.Field;
import java.util.List;

import org.xj4.XJ4TestClass;

/**
 * @author jbunting
 * @TODO Document Me!
 * Created by IntelliJ IDEA.
 * Date: Mar 5, 2008
 * Time: 8:06:26 AM
 */
public interface Lifecycle {

  public boolean supportsClassLevel();

  public boolean supportsInstanceLevel();

  public void start(XJ4TestClass testClass, Field field, Object target);
  public void stop(XJ4TestClass testClass, Field field, Object target);

  public Class<?> requiredType();

  public boolean acceptsNull();

  public void validate(List<Throwable> errors, Field field);
}
